﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TypicalCSharp
{
    public class Typical
    {

        //Deklaration von internen Datenspeichern
        private float[] open;
        private float[] high;
        private float[] low;
        private float[] close;
        private int size; //Anzahl Perioden

        /**
         * Initialisieren von internen Datenspeichern
         * */
        private void init(ref KSEImportExport6.KSEDataCollection cDaten) 
        {
            size = cDaten.get_UpperBound("Close"); //Anzahl Perioden
            open = new float[size];
            high = new float[size];
            low = new float[size];
            close = new float[size];
        }

        /**
         * Kopiert Perioden Daten in interene Arrays. 
         * return false wenn dabei was nicht klappt
         * */
        private bool datenKopieren(ref KSEImportExport6.KSEDataCollection cDaten)
        {
            //Speichern der neuen Perioden in den Arrays
            if(cDaten.CopySingleFeldToAddress("Open", ref open[0], size)!= true) return false;
            if(cDaten.CopySingleFeldToAddress("High", ref high[0], size)!= true) return false;
            if(cDaten.CopySingleFeldToAddress("Low", ref low[0], size)!= true) return false;
            if(cDaten.CopySingleFeldToAddress("Close", ref close[0], size) != true) return false;
            return true;
        }


        /**Berechnung des Indikators
         * return false wenn was schief geht
         * return true wenn alles klappt
         */
        public bool Calculate(ref KSEImportExport6.KSEDataCollection cDaten, ref object Parameter, ref object o)
        {
            //Befuellen von internen Datenspeichern
            init(ref cDaten);
            if (datenKopieren(ref cDaten) != true) return false;

            //Ergebnis Objekt casten
            float[] ergebnis = (float[])o;

            //Hier jetzt die Berechnung des Ergebnisses
            for (int i = 0; i < size; ++i)
            {
                //der typische Preis ist = (High + Low + Close)/3
                //beschreibt den Tageskurs tendenziell besser als der einfache Close.
                float typical = (high[i] + low[i] + close[i]) / 3;
                ergebnis[i] = typical;
            }

            //Beenden und zurueck geben der Daten
            return true;
        }
    }
}
